<?php

namespace Dpd\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for internationalLine StructType
 * @subpackage Structs
 */
class InternationalLine extends AbstractStructBase
{
    /**
     * The customsTarif
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $customsTarif;
    /**
     * The receiverCustomsTarif
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $receiverCustomsTarif;
    /**
     * The content
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $content;
    /**
     * The grossWeight
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $grossWeight;
    /**
     * The itemsNumber
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $itemsNumber;
    /**
     * The amountLine
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $amountLine;
    /**
     * The productCode
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $productCode;
    /**
     * The customsOrigin
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $customsOrigin;
    /**
     * The invoicePosition
     * Meta information extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $invoicePosition;
    /**
     * Constructor method for internationalLine
     * @uses InternationalLine::setCustomsTarif()
     * @uses InternationalLine::setReceiverCustomsTarif()
     * @uses InternationalLine::setContent()
     * @uses InternationalLine::setGrossWeight()
     * @uses InternationalLine::setItemsNumber()
     * @uses InternationalLine::setAmountLine()
     * @uses InternationalLine::setProductCode()
     * @uses InternationalLine::setCustomsOrigin()
     * @uses InternationalLine::setInvoicePosition()
     * @param string $customsTarif
     * @param string $receiverCustomsTarif
     * @param string $content
     * @param int $grossWeight
     * @param int $itemsNumber
     * @param int $amountLine
     * @param string $productCode
     * @param string $customsOrigin
     * @param string $invoicePosition
     */
    public function __construct($customsTarif = null, $receiverCustomsTarif = null, $content = null, $grossWeight = null, $itemsNumber = null, $amountLine = null, $productCode = null, $customsOrigin = null, $invoicePosition = null)
    {
        $this
            ->setCustomsTarif($customsTarif)
            ->setReceiverCustomsTarif($receiverCustomsTarif)
            ->setContent($content)
            ->setGrossWeight($grossWeight)
            ->setItemsNumber($itemsNumber)
            ->setAmountLine($amountLine)
            ->setProductCode($productCode)
            ->setCustomsOrigin($customsOrigin)
            ->setInvoicePosition($invoicePosition);
    }
    /**
     * Get customsTarif value
     * @return string
     */
    public function getCustomsTarif()
    {
        return $this->customsTarif;
    }
    /**
     * Set customsTarif value
     * @param string $customsTarif
     * @return \Dpd\StructType\InternationalLine
     */
    public function setCustomsTarif($customsTarif = null)
    {
        // validation for constraint: string
        if (!is_null($customsTarif) && !is_string($customsTarif)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customsTarif, true), gettype($customsTarif)), __LINE__);
        }
        $this->customsTarif = $customsTarif;
        return $this;
    }
    /**
     * Get receiverCustomsTarif value
     * @return string
     */
    public function getReceiverCustomsTarif()
    {
        return $this->receiverCustomsTarif;
    }
    /**
     * Set receiverCustomsTarif value
     * @param string $receiverCustomsTarif
     * @return \Dpd\StructType\InternationalLine
     */
    public function setReceiverCustomsTarif($receiverCustomsTarif = null)
    {
        // validation for constraint: string
        if (!is_null($receiverCustomsTarif) && !is_string($receiverCustomsTarif)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiverCustomsTarif, true), gettype($receiverCustomsTarif)), __LINE__);
        }
        $this->receiverCustomsTarif = $receiverCustomsTarif;
        return $this;
    }
    /**
     * Get content value
     * @return string
     */
    public function getContent()
    {
        return $this->content;
    }
    /**
     * Set content value
     * @param string $content
     * @return \Dpd\StructType\InternationalLine
     */
    public function setContent($content = null)
    {
        // validation for constraint: string
        if (!is_null($content) && !is_string($content)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($content, true), gettype($content)), __LINE__);
        }
        $this->content = $content;
        return $this;
    }
    /**
     * Get grossWeight value
     * @return int
     */
    public function getGrossWeight()
    {
        return $this->grossWeight;
    }
    /**
     * Set grossWeight value
     * @param int $grossWeight
     * @return \Dpd\StructType\InternationalLine
     */
    public function setGrossWeight($grossWeight = null)
    {
        // validation for constraint: int
        if (!is_null($grossWeight) && !(is_int($grossWeight) || ctype_digit($grossWeight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($grossWeight, true), gettype($grossWeight)), __LINE__);
        }
        $this->grossWeight = $grossWeight;
        return $this;
    }
    /**
     * Get itemsNumber value
     * @return int
     */
    public function getItemsNumber()
    {
        return $this->itemsNumber;
    }
    /**
     * Set itemsNumber value
     * @param int $itemsNumber
     * @return \Dpd\StructType\InternationalLine
     */
    public function setItemsNumber($itemsNumber = null)
    {
        // validation for constraint: int
        if (!is_null($itemsNumber) && !(is_int($itemsNumber) || ctype_digit($itemsNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($itemsNumber, true), gettype($itemsNumber)), __LINE__);
        }
        $this->itemsNumber = $itemsNumber;
        return $this;
    }
    /**
     * Get amountLine value
     * @return int
     */
    public function getAmountLine()
    {
        return $this->amountLine;
    }
    /**
     * Set amountLine value
     * @param int $amountLine
     * @return \Dpd\StructType\InternationalLine
     */
    public function setAmountLine($amountLine = null)
    {
        // validation for constraint: int
        if (!is_null($amountLine) && !(is_int($amountLine) || ctype_digit($amountLine))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amountLine, true), gettype($amountLine)), __LINE__);
        }
        $this->amountLine = $amountLine;
        return $this;
    }
    /**
     * Get productCode value
     * @return string|null
     */
    public function getProductCode()
    {
        return $this->productCode;
    }
    /**
     * Set productCode value
     * @param string $productCode
     * @return \Dpd\StructType\InternationalLine
     */
    public function setProductCode($productCode = null)
    {
        // validation for constraint: string
        if (!is_null($productCode) && !is_string($productCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productCode, true), gettype($productCode)), __LINE__);
        }
        $this->productCode = $productCode;
        return $this;
    }
    /**
     * Get customsOrigin value
     * @return string|null
     */
    public function getCustomsOrigin()
    {
        return $this->customsOrigin;
    }
    /**
     * Set customsOrigin value
     * @param string $customsOrigin
     * @return \Dpd\StructType\InternationalLine
     */
    public function setCustomsOrigin($customsOrigin = null)
    {
        // validation for constraint: string
        if (!is_null($customsOrigin) && !is_string($customsOrigin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customsOrigin, true), gettype($customsOrigin)), __LINE__);
        }
        $this->customsOrigin = $customsOrigin;
        return $this;
    }
    /**
     * Get invoicePosition value
     * @return string|null
     */
    public function getInvoicePosition()
    {
        return $this->invoicePosition;
    }
    /**
     * Set invoicePosition value
     * @param string $invoicePosition
     * @return \Dpd\StructType\InternationalLine
     */
    public function setInvoicePosition($invoicePosition = null)
    {
        // validation for constraint: string
        if (!is_null($invoicePosition) && !is_string($invoicePosition)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoicePosition, true), gettype($invoicePosition)), __LINE__);
        }
        $this->invoicePosition = $invoicePosition;
        return $this;
    }
}
